oss-fuzz/build: remove LIB_FUZZING_ENGINE
[qemu.git] / scripts / oss-fuzz / build.sh
1 #!/bin/sh -e
2 #
3 # OSS-Fuzz build script. See:
4 # https://google.github.io/oss-fuzz/getting-started/new-project-guide/#buildsh
5 #
6 # The file is consumed by:
7 # https://github.com/google/oss-fuzz/blob/master/projects/qemu/Dockerfiles
8 #
9 # This code is licensed under the GPL version 2 or later. See
10 # the COPYING file in the top-level directory.
11 #
12
13 # build project
14 # e.g.
15 # ./autogen.sh
16 # ./configure
17 # make -j$(nproc) all
18
19 # build fuzzers
20 # e.g.
21 # $CXX $CXXFLAGS -std=c++11 -Iinclude \
22 # /path/to/name_of_fuzzer.cc -o $OUT/name_of_fuzzer \
23 # -fsanitize=fuzzer /path/to/library.a
24
25 fatal () {
26 echo "Error : ${*}, exiting."
27 exit 1
28 }
29
30 OSS_FUZZ_BUILD_DIR="./build-oss-fuzz/"
31
32 # There seems to be a bug in clang-11 (used for builds on oss-fuzz) :
33 # accel/tcg/cputlb.o: In function `load_memop':
34 # accel/tcg/cputlb.c:1505: undefined reference to `qemu_build_not_reached'
35 #
36 # When building with optimization, the compiler is expected to prove that the
37 # statement cannot be reached, and remove it. For some reason clang-11 doesn't
38 # remove it, resulting in an unresolved reference to qemu_build_not_reached
39 # Undefine the __OPTIMIZE__ macro which compiler.h relies on to choose whether
40 # to " #define qemu_build_not_reached() g_assert_not_reached() "
41 EXTRA_CFLAGS="$CFLAGS -U __OPTIMIZE__"
42
43 if ! { [ -e "./COPYING" ] &&
44 [ -e "./MAINTAINERS" ] &&
45 [ -e "./Makefile" ] &&
46 [ -e "./docs" ] &&
47 [ -e "./VERSION" ] &&
48 [ -e "./linux-user" ] &&
49 [ -e "./softmmu" ];} ; then
50 fatal "Please run the script from the top of the QEMU tree"
51 fi
52
53 mkdir -p $OSS_FUZZ_BUILD_DIR || fatal "mkdir $OSS_FUZZ_BUILD_DIR failed"
54 cd $OSS_FUZZ_BUILD_DIR || fatal "cd $OSS_FUZZ_BUILD_DIR failed"
55
56
57 if [ -z ${OUT+x} ]; then
58 DEST_DIR=$(realpath "./DEST_DIR")
59 else
60 DEST_DIR=$OUT
61 fi
62
63 mkdir -p "$DEST_DIR/lib/" # Copy the shared libraries here
64
65 # Build once to get the list of dynamic lib paths, and copy them over
66 ../configure --disable-werror --cc="$CC" --cxx="$CXX" --enable-fuzzing \
67 --extra-cflags="$EXTRA_CFLAGS" --target-list="i386-softmmu"
68
69 if ! make "-j$(nproc)" i386-softmmu/fuzz; then
70 fatal "Build failed. Please specify a compiler with fuzzing support"\
71 "using the \$CC and \$CXX environemnt variables"\
72 "\nFor example: CC=clang CXX=clang++ $0"
73 fi
74
75 for i in $(ldd ./i386-softmmu/qemu-fuzz-i386 | cut -f3 -d' '); do
76 cp "$i" "$DEST_DIR/lib/"
77 done
78 rm ./i386-softmmu/qemu-fuzz-i386
79
80 # Build a second time to build the final binary with correct rpath
81 ../configure --bindir="$DEST_DIR" --datadir="$DEST_DIR/data/" --disable-werror \
82 --cc="$CC" --cxx="$CXX" --extra-cflags="$EXTRA_CFLAGS" \
83 --extra-ldflags="-Wl,-rpath,'\$\$ORIGIN/lib'"
84 make "-j$(nproc)" i386-softmmu/fuzz
85
86 # Copy over the datadir
87 cp -r ../pc-bios/ "$DEST_DIR/pc-bios"
88
89 # Run the fuzzer with no arguments, to print the help-string and get the list
90 # of available fuzz-targets. Copy over the qemu-fuzz-i386, naming it according
91 # to each available fuzz target (See 05509c8e6d fuzz: select fuzz target using
92 # executable name)
93 for target in $(./i386-softmmu/qemu-fuzz-i386 | awk '$1 ~ /\*/ {print $2}');
94 do
95 cp ./i386-softmmu/qemu-fuzz-i386 "$DEST_DIR/qemu-fuzz-i386-target-$target"
96 done
97
98 echo "Done. The fuzzers are located in $DEST_DIR"
99 exit 0